Improve debugging output of DRBD8 status
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 # Enable colors in shelltest
24 SHELLTESTARGS = "-c"
25
26 ACLOCAL_AMFLAGS = -I autotools
27 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
28 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
29 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
30 CHECK_HEADER = $(top_srcdir)/autotools/check-header
31 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
32 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
33 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
34 CHECK_VERSION = $(top_srcdir)/autotools/check-version
35 CHECK_NEWS = $(top_srcdir)/autotools/check-news
36 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
37 DOCPP = $(top_srcdir)/autotools/docpp
38 REPLACE_VARS_SED = autotools/replace_vars.sed
39 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
40 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
41 SHELL_ENV_INIT = autotools/shell-env-init
42
43 # Note: these are automake-specific variables, and must be named after
44 # the directory + 'dir' suffix
45 clientdir = $(pkgpythondir)/client
46 cmdlibdir = $(pkgpythondir)/cmdlib
47 hypervisordir = $(pkgpythondir)/hypervisor
48 storagedir = $(pkgpythondir)/storage
49 httpdir = $(pkgpythondir)/http
50 masterddir = $(pkgpythondir)/masterd
51 confddir = $(pkgpythondir)/confd
52 rapidir = $(pkgpythondir)/rapi
53 serverdir = $(pkgpythondir)/server
54 watcherdir = $(pkgpythondir)/watcher
55 impexpddir = $(pkgpythondir)/impexpd
56 utilsdir = $(pkgpythondir)/utils
57 toolsdir = $(pkglibdir)/tools
58 iallocatorsdir = $(pkglibdir)/iallocators
59 pytoolsdir = $(pkgpythondir)/tools
60 docdir = $(datadir)/doc/$(PACKAGE)
61 myexeclibdir = $(pkglibdir)
62
63 # Delete output file if an error occurred while building it
64 .DELETE_ON_ERROR:
65
66 HS_DIRS = \
67         src \
68         src/Ganeti \
69         src/Ganeti/Confd \
70         src/Ganeti/Curl \
71         src/Ganeti/DataCollectors \
72         src/Ganeti/HTools \
73         src/Ganeti/HTools/Backend \
74         src/Ganeti/HTools/Program \
75         src/Ganeti/Hypervisor \
76         src/Ganeti/Hypervisor/Xen \
77         src/Ganeti/Monitoring \
78         src/Ganeti/Query \
79         src/Ganeti/Storage \
80         src/Ganeti/Storage/Diskstats \
81         src/Ganeti/Storage/Drbd \
82         src/Ganeti/Storage/Lvm \
83         test/hs \
84         test/hs/Test \
85         test/hs/Test/Ganeti \
86         test/hs/Test/Ganeti/Storage \
87         test/hs/Test/Ganeti/Storage/Diskstats \
88         test/hs/Test/Ganeti/Storage/Drbd \
89         test/hs/Test/Ganeti/Storage/Lvm \
90         test/hs/Test/Ganeti/Confd \
91         test/hs/Test/Ganeti/HTools \
92         test/hs/Test/Ganeti/HTools/Backend \
93         test/hs/Test/Ganeti/Hypervisor \
94         test/hs/Test/Ganeti/Hypervisor/Xen \
95         test/hs/Test/Ganeti/Query
96
97 # Haskell directories without the roots (src, test/hs)
98 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
99
100 DIRS = \
101         $(HS_DIRS) \
102         autotools \
103         daemons \
104         devel \
105         devel/data \
106         doc \
107         doc/css \
108         doc/examples \
109         doc/examples/gnt-debug \
110         doc/examples/hooks \
111         test/data/htools \
112         test/data/htools/rapi \
113         test/hs/shelltests \
114         test/autotools \
115         lib \
116         lib/build \
117         lib/client \
118         lib/cmdlib \
119         lib/confd \
120         lib/http \
121         lib/hypervisor \
122         lib/impexpd \
123         lib/masterd \
124         lib/rapi \
125         lib/server \
126         lib/storage \
127         lib/tools \
128         lib/utils \
129         lib/watcher \
130         man \
131         qa \
132         test \
133         test/data \
134         test/data/bdev-rbd \
135         test/data/ovfdata \
136         test/data/ovfdata/other \
137         test/py \
138         tools
139
140 ALL_APIDOC_HS_DIRS = \
141         $(APIDOC_HS_DIR) \
142         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
143
144 BUILDTIME_DIR_AUTOCREATE = \
145         scripts \
146         $(APIDOC_DIR) \
147         $(ALL_APIDOC_HS_DIRS) \
148         $(APIDOC_PY_DIR) \
149         $(COVERAGE_DIR) \
150         $(COVERAGE_HS_DIR) \
151         $(COVERAGE_PY_DIR) \
152         .hpc
153
154 BUILDTIME_DIRS = \
155         $(BUILDTIME_DIR_AUTOCREATE) \
156         doc/html \
157         doc/man-html
158
159 DIRCHECK_EXCLUDE = \
160         $(BUILDTIME_DIRS) \
161         ganeti-[0-9]*.[0-9]*.[0-9]* \
162         doc/html/_* \
163         doc/man-html/_* \
164         autom4te.cache
165
166 # some helper vars
167 COVERAGE_DIR = doc/coverage
168 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
169 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
170 APIDOC_DIR = doc/api
171 APIDOC_PY_DIR = $(APIDOC_DIR)/py
172 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
173
174 MAINTAINERCLEANFILES = \
175         $(maninput) \
176         doc/install-quick.rst \
177         doc/news.rst \
178         doc/upgrade.rst \
179         vcs-version
180
181 maintainer-clean-local:
182         rm -rf $(BUILDTIME_DIRS)
183
184 CLEANFILES = \
185         $(addsuffix /*.py[co],$(DIRS)) \
186         $(addsuffix /*.hi,$(HS_DIRS)) \
187         $(addsuffix /*.o,$(HS_DIRS)) \
188         $(PYTHON_BOOTSTRAP) \
189         epydoc.conf \
190         $(REPLACE_VARS_SED) \
191         $(SHELL_ENV_INIT) \
192         daemons/daemon-util \
193         daemons/ganeti-cleaner \
194         devel/squeeze-amd64.tar.gz \
195         devel/squeeze-amd64.conf \
196         $(mandocrst) \
197         doc/manpages-enabled.rst \
198         $(BUILT_EXAMPLES) \
199         doc/examples/bash_completion \
200         doc/examples/bash_completion-debug \
201         lib/_generated_rpc.py \
202         $(man_MANS) \
203         $(manhtml) \
204         tools/kvm-ifup \
205         tools/vif-ganeti \
206         tools/net-common \
207         tools/users-setup \
208         tools/vcluster-setup \
209         stamp-directories \
210         stamp-srclinks \
211         $(nodist_pkgpython_PYTHON) \
212         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
213         $(HS_BUILT_TEST_HELPERS) \
214         src/ganeti-confd \
215         src/ganeti-mond \
216         .hpc/*.mix src/*.tix test/hs/*.tix \
217         doc/hs-lint.html
218
219 GENERATED_FILES = \
220         $(built_base_sources) \
221         $(BUILT_PYTHON_SOURCES) \
222         $(PYTHON_BOOTSTRAP)
223
224 HS_GENERATED_FILES =
225 if WANT_HTOOLS
226 HS_GENERATED_FILES += $(HS_PROGS)
227 if ENABLE_CONFD
228 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
229 endif
230
231 if ENABLE_MOND
232 HS_GENERATED_FILES += src/ganeti-mond
233 endif
234 endif
235
236 built_base_sources = \
237         stamp-directories \
238         stamp-srclinks
239
240 built_python_base_sources = \
241         lib/_autoconf.py \
242         lib/_vcsversion.py
243
244 BUILT_PYTHON_SOURCES = \
245         $(built_python_base_sources) \
246         lib/_generated_rpc.py
247
248 # Generating the RPC wrappers depends on many things, so make sure
249 # it's built at the end of the built sources
250 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
251
252 # these are all built from the underlying %.in sources
253 BUILT_EXAMPLES = \
254         doc/examples/ganeti-kvm-poweroff.initd \
255         doc/examples/ganeti.cron \
256         doc/examples/ganeti.initd \
257         doc/examples/ganeti-master-role.ocf \
258         doc/examples/ganeti-node-role.ocf \
259         doc/examples/gnt-config-backup \
260         doc/examples/hooks/ipsec
261
262 nodist_pkgpython_PYTHON = \
263         $(BUILT_PYTHON_SOURCES)
264
265 noinst_PYTHON = \
266         lib/build/__init__.py \
267         lib/build/shell_example_lexer.py \
268         lib/build/sphinx_ext.py
269
270 pkgpython_PYTHON = \
271         lib/__init__.py \
272         lib/asyncnotifier.py \
273         lib/backend.py \
274         lib/bootstrap.py \
275         lib/cli.py \
276         lib/compat.py \
277         lib/config.py \
278         lib/constants.py \
279         lib/daemon.py \
280         lib/errors.py \
281         lib/hooksmaster.py \
282         lib/ht.py \
283         lib/jqueue.py \
284         lib/jstore.py \
285         lib/locking.py \
286         lib/luxi.py \
287         lib/mcpu.py \
288         lib/netutils.py \
289         lib/objects.py \
290         lib/opcodes.py \
291         lib/outils.py \
292         lib/ovf.py \
293         lib/pathutils.py \
294         lib/qlang.py \
295         lib/query.py \
296         lib/rpc.py \
297         lib/rpc_defs.py \
298         lib/runtime.py \
299         lib/serializer.py \
300         lib/ssconf.py \
301         lib/ssh.py \
302         lib/uidpool.py \
303         lib/vcluster.py \
304         lib/network.py \
305         lib/workerpool.py
306
307 client_PYTHON = \
308         lib/client/__init__.py \
309         lib/client/gnt_backup.py \
310         lib/client/gnt_cluster.py \
311         lib/client/gnt_debug.py \
312         lib/client/gnt_group.py \
313         lib/client/gnt_instance.py \
314         lib/client/gnt_job.py \
315         lib/client/gnt_node.py \
316         lib/client/gnt_network.py \
317         lib/client/gnt_os.py \
318         lib/client/gnt_storage.py
319
320 cmdlib_PYTHON = \
321         lib/cmdlib/__init__.py \
322         lib/cmdlib/backup.py \
323         lib/cmdlib/base.py \
324         lib/cmdlib/cluster.py \
325         lib/cmdlib/common.py \
326         lib/cmdlib/group.py \
327         lib/cmdlib/instance.py \
328         lib/cmdlib/instance_migration.py \
329         lib/cmdlib/instance_operation.py \
330         lib/cmdlib/instance_query.py \
331         lib/cmdlib/instance_storage.py \
332         lib/cmdlib/instance_utils.py \
333         lib/cmdlib/misc.py \
334         lib/cmdlib/network.py \
335         lib/cmdlib/node.py \
336         lib/cmdlib/operating_system.py \
337         lib/cmdlib/query.py \
338         lib/cmdlib/tags.py \
339         lib/cmdlib/test.py
340
341 hypervisor_PYTHON = \
342         lib/hypervisor/__init__.py \
343         lib/hypervisor/hv_base.py \
344         lib/hypervisor/hv_chroot.py \
345         lib/hypervisor/hv_fake.py \
346         lib/hypervisor/hv_kvm.py \
347         lib/hypervisor/hv_lxc.py \
348         lib/hypervisor/hv_xen.py
349
350 storage_PYTHON = \
351         lib/storage/__init__.py \
352         lib/storage/bdev.py \
353         lib/storage/base.py \
354         lib/storage/container.py \
355         lib/storage/drbd.py \
356         lib/storage/drbd_info.py \
357         lib/storage/drbd_cmdgen.py \
358         lib/storage/filestorage.py
359
360 rapi_PYTHON = \
361         lib/rapi/__init__.py \
362         lib/rapi/baserlib.py \
363         lib/rapi/client.py \
364         lib/rapi/client_utils.py \
365         lib/rapi/connector.py \
366         lib/rapi/rlib2.py \
367         lib/rapi/testutils.py
368
369 http_PYTHON = \
370         lib/http/__init__.py \
371         lib/http/auth.py \
372         lib/http/client.py \
373         lib/http/server.py
374
375 confd_PYTHON = \
376         lib/confd/__init__.py \
377         lib/confd/client.py
378
379 masterd_PYTHON = \
380         lib/masterd/__init__.py \
381         lib/masterd/iallocator.py \
382         lib/masterd/instance.py
383
384 impexpd_PYTHON = \
385         lib/impexpd/__init__.py
386
387 watcher_PYTHON = \
388         lib/watcher/__init__.py \
389         lib/watcher/nodemaint.py \
390         lib/watcher/state.py
391
392 server_PYTHON = \
393         lib/server/__init__.py \
394         lib/server/masterd.py \
395         lib/server/noded.py \
396         lib/server/rapi.py
397
398 pytools_PYTHON = \
399         lib/tools/__init__.py \
400         lib/tools/burnin.py \
401         lib/tools/ensure_dirs.py \
402         lib/tools/node_cleanup.py \
403         lib/tools/node_daemon_setup.py \
404         lib/tools/prepare_node_join.py
405
406 utils_PYTHON = \
407         lib/utils/__init__.py \
408         lib/utils/algo.py \
409         lib/utils/filelock.py \
410         lib/utils/hash.py \
411         lib/utils/io.py \
412         lib/utils/log.py \
413         lib/utils/lvm.py \
414         lib/utils/mlock.py \
415         lib/utils/nodesetup.py \
416         lib/utils/process.py \
417         lib/utils/retry.py \
418         lib/utils/storage.py \
419         lib/utils/text.py \
420         lib/utils/wrapper.py \
421         lib/utils/x509.py
422
423 docinput = \
424         doc/conf.py \
425         doc/css/style.css \
426         doc/admin.rst \
427         doc/cluster-merge.rst \
428         doc/design-2.0.rst \
429         doc/design-2.1.rst \
430         doc/design-2.2.rst \
431         doc/design-2.3.rst \
432         doc/design-2.4.rst \
433         doc/design-2.5.rst \
434         doc/design-2.6.rst \
435         doc/design-2.7.rst \
436         doc/design-2.8.rst \
437         doc/design-autorepair.rst \
438         doc/design-bulk-create.rst \
439         doc/design-chained-jobs.rst \
440         doc/design-cpu-pinning.rst \
441         doc/design-device-uuid-name.rst \
442         doc/design-draft.rst \
443         doc/design-htools-2.3.rst \
444         doc/design-http-server.rst \
445         doc/design-impexp2.rst \
446         doc/design-internal-shutdown.rst \
447         doc/design-lu-generated-jobs.rst \
448         doc/design-linuxha.rst \
449         doc/design-multi-reloc.rst \
450         doc/design-network.rst \
451         doc/design-node-add.rst \
452         doc/design-oob.rst \
453         doc/design-ovf-support.rst \
454         doc/design-opportunistic-locking.rst \
455         doc/design-partitioned.rst \
456         doc/design-query-splitting.rst \
457         doc/design-query2.rst \
458         doc/design-reason-trail.rst \
459         doc/design-resource-model.rst \
460         doc/design-restricted-commands.rst \
461         doc/design-shared-storage.rst \
462         doc/design-monitoring-agent.rst \
463         doc/design-virtual-clusters.rst \
464         doc/design-x509-ca.rst \
465         doc/design-hroller.rst \
466         doc/design-storagetypes.rst \
467         doc/devnotes.rst \
468         doc/glossary.rst \
469         doc/hooks.rst \
470         doc/iallocator.rst \
471         doc/index.rst \
472         doc/install-quick.rst \
473         doc/install.rst \
474         doc/locking.rst \
475         doc/manpages-disabled.rst \
476         doc/move-instance.rst \
477         doc/news.rst \
478         doc/ovfconverter.rst \
479         doc/rapi.rst \
480         doc/security.rst \
481         doc/upgrade.rst \
482         doc/virtual-cluster.rst \
483         doc/walkthrough.rst
484
485 # Generates file names such as "doc/man-gnt-instance.rst"
486 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
487
488 # Haskell programs to be installed in $PREFIX/bin
489 HS_BIN_PROGS=src/htools
490
491 # Haskell programs to be installed in the MYEXECLIB dir
492 if ENABLE_MOND
493 HS_MYEXECLIB_PROGS=src/mon-collector
494 else
495 HS_MYEXECLIB_PROGS=
496 endif
497
498 # Haskell programs to be compiled by "make really-all"
499 HS_COMPILE_PROGS= \
500         src/ganeti-mond \
501         src/hconfd \
502         src/rpc-test
503
504 # All Haskell non-test programs to be compiled but not automatically installed
505 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
506
507 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
508 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
509
510 HS_ALL_PROGS = \
511         $(HS_PROGS) \
512         test/hs/hpc-htools \
513         test/hs/hpc-mon-collector \
514         test/hs/htest \
515         $(HS_COMPILE_PROGS)
516
517 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
518 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
519
520 HFLAGS = \
521         -O -Wall -Werror -isrc \
522         -fwarn-monomorphism-restriction \
523         -fwarn-tabs \
524         $(GHC_BYVERSION_FLAGS)
525
526 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
527 HEXTRA =
528 # internal extra flags (used for test/hs/htest mainly)
529 HEXTRA_INT =
530 # exclude options for coverage reports
531 HPCEXCL = --exclude Main \
532         --exclude Ganeti.Constants \
533         --exclude Ganeti.HTools.QC \
534         --exclude Ganeti.THH \
535         --exclude Ganeti.Version \
536         --exclude Test.Ganeti.Attoparsec \
537         --exclude Test.Ganeti.TestCommon \
538         --exclude Test.Ganeti.TestHTools \
539         --exclude Test.Ganeti.TestHelper \
540         --exclude Test.Ganeti.TestImports \
541         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
542
543 HS_LIB_SRCS = \
544         src/Ganeti/BasicTypes.hs \
545         src/Ganeti/Common.hs \
546         src/Ganeti/Compat.hs \
547         src/Ganeti/Confd/Client.hs \
548         src/Ganeti/Confd/ClientFunctions.hs \
549         src/Ganeti/Confd/Server.hs \
550         src/Ganeti/Confd/Types.hs \
551         src/Ganeti/Confd/Utils.hs \
552         src/Ganeti/Config.hs \
553         src/Ganeti/Curl/Multi.hs \
554         src/Ganeti/Daemon.hs \
555         src/Ganeti/DataCollectors/CLI.hs \
556         src/Ganeti/DataCollectors/Diskstats.hs \
557         src/Ganeti/DataCollectors/Drbd.hs \
558         src/Ganeti/DataCollectors/InstStatus.hs \
559         src/Ganeti/DataCollectors/InstStatusTypes.hs \
560         src/Ganeti/DataCollectors/Lv.hs \
561         src/Ganeti/DataCollectors/Program.hs \
562         src/Ganeti/DataCollectors/Types.hs \
563         src/Ganeti/Errors.hs \
564         src/Ganeti/HTools/Backend/IAlloc.hs \
565         src/Ganeti/HTools/Backend/Luxi.hs \
566         src/Ganeti/HTools/Backend/Rapi.hs \
567         src/Ganeti/HTools/Backend/Simu.hs \
568         src/Ganeti/HTools/Backend/Text.hs \
569         src/Ganeti/HTools/CLI.hs \
570         src/Ganeti/HTools/Cluster.hs \
571         src/Ganeti/HTools/Container.hs \
572         src/Ganeti/HTools/ExtLoader.hs \
573         src/Ganeti/HTools/Graph.hs \
574         src/Ganeti/HTools/Group.hs \
575         src/Ganeti/HTools/Instance.hs \
576         src/Ganeti/HTools/Loader.hs \
577         src/Ganeti/HTools/Nic.hs \
578         src/Ganeti/HTools/Node.hs \
579         src/Ganeti/HTools/PeerMap.hs \
580         src/Ganeti/HTools/Program/Hail.hs \
581         src/Ganeti/HTools/Program/Harep.hs \
582         src/Ganeti/HTools/Program/Hbal.hs \
583         src/Ganeti/HTools/Program/Hcheck.hs \
584         src/Ganeti/HTools/Program/Hinfo.hs \
585         src/Ganeti/HTools/Program/Hscan.hs \
586         src/Ganeti/HTools/Program/Hspace.hs \
587         src/Ganeti/HTools/Program/Hroller.hs \
588         src/Ganeti/HTools/Program/Main.hs \
589         src/Ganeti/HTools/Types.hs \
590         src/Ganeti/Hypervisor/Xen.hs \
591         src/Ganeti/Hypervisor/Xen/XmParser.hs \
592         src/Ganeti/Hypervisor/Xen/Types.hs \
593         src/Ganeti/Hash.hs \
594         src/Ganeti/JQueue.hs \
595         src/Ganeti/JSON.hs \
596         src/Ganeti/Jobs.hs \
597         src/Ganeti/Logging.hs \
598         src/Ganeti/Luxi.hs \
599         src/Ganeti/Monitoring/Server.hs \
600         src/Ganeti/Network.hs \
601         src/Ganeti/Objects.hs \
602         src/Ganeti/OpCodes.hs \
603         src/Ganeti/OpParams.hs \
604         src/Ganeti/Path.hs \
605         src/Ganeti/Query/Cluster.hs \
606         src/Ganeti/Query/Common.hs \
607         src/Ganeti/Query/Export.hs \
608         src/Ganeti/Query/Filter.hs \
609         src/Ganeti/Query/Group.hs \
610         src/Ganeti/Query/Job.hs \
611         src/Ganeti/Query/Language.hs \
612         src/Ganeti/Query/Network.hs \
613         src/Ganeti/Query/Node.hs \
614         src/Ganeti/Query/Query.hs \
615         src/Ganeti/Query/Server.hs \
616         src/Ganeti/Query/Types.hs \
617         src/Ganeti/Rpc.hs \
618         src/Ganeti/Runtime.hs \
619         src/Ganeti/Ssconf.hs \
620         src/Ganeti/Storage/Diskstats/Parser.hs \
621         src/Ganeti/Storage/Diskstats/Types.hs \
622         src/Ganeti/Storage/Drbd/Parser.hs \
623         src/Ganeti/Storage/Drbd/Types.hs \
624         src/Ganeti/Storage/Lvm/LVParser.hs \
625         src/Ganeti/Storage/Lvm/Types.hs \
626         src/Ganeti/Storage/Utils.hs \
627         src/Ganeti/THH.hs \
628         src/Ganeti/Types.hs \
629         src/Ganeti/Utils.hs
630
631 HS_TEST_SRCS = \
632         test/hs/Test/Ganeti/Attoparsec.hs \
633         test/hs/Test/Ganeti/BasicTypes.hs \
634         test/hs/Test/Ganeti/Common.hs \
635         test/hs/Test/Ganeti/Confd/Types.hs \
636         test/hs/Test/Ganeti/Confd/Utils.hs \
637         test/hs/Test/Ganeti/Daemon.hs \
638         test/hs/Test/Ganeti/Errors.hs \
639         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
640         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
641         test/hs/Test/Ganeti/HTools/CLI.hs \
642         test/hs/Test/Ganeti/HTools/Cluster.hs \
643         test/hs/Test/Ganeti/HTools/Container.hs \
644         test/hs/Test/Ganeti/HTools/Graph.hs \
645         test/hs/Test/Ganeti/HTools/Instance.hs \
646         test/hs/Test/Ganeti/HTools/Loader.hs \
647         test/hs/Test/Ganeti/HTools/Node.hs \
648         test/hs/Test/Ganeti/HTools/PeerMap.hs \
649         test/hs/Test/Ganeti/HTools/Types.hs \
650         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
651         test/hs/Test/Ganeti/JSON.hs \
652         test/hs/Test/Ganeti/Jobs.hs \
653         test/hs/Test/Ganeti/JQueue.hs \
654         test/hs/Test/Ganeti/Luxi.hs \
655         test/hs/Test/Ganeti/Network.hs \
656         test/hs/Test/Ganeti/Objects.hs \
657         test/hs/Test/Ganeti/OpCodes.hs \
658         test/hs/Test/Ganeti/Query/Filter.hs \
659         test/hs/Test/Ganeti/Query/Language.hs \
660         test/hs/Test/Ganeti/Query/Network.hs \
661         test/hs/Test/Ganeti/Query/Query.hs \
662         test/hs/Test/Ganeti/Rpc.hs \
663         test/hs/Test/Ganeti/Runtime.hs \
664         test/hs/Test/Ganeti/Ssconf.hs \
665         test/hs/Test/Ganeti/Storage/Diskstats/Parser.hs \
666         test/hs/Test/Ganeti/Storage/Drbd/Parser.hs \
667         test/hs/Test/Ganeti/Storage/Drbd/Types.hs \
668         test/hs/Test/Ganeti/Storage/Lvm/LVParser.hs \
669         test/hs/Test/Ganeti/THH.hs \
670         test/hs/Test/Ganeti/TestCommon.hs \
671         test/hs/Test/Ganeti/TestHTools.hs \
672         test/hs/Test/Ganeti/TestHelper.hs \
673         test/hs/Test/Ganeti/Types.hs \
674         test/hs/Test/Ganeti/Utils.hs
675
676 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
677
678 HS_BUILT_SRCS = \
679         test/hs/Test/Ganeti/TestImports.hs \
680         src/Ganeti/Constants.hs \
681         src/Ganeti/Curl/Internal.hs \
682         src/Ganeti/Version.hs
683 HS_BUILT_SRCS_IN = \
684         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
685         src/Ganeti/Curl/Internal.hsc
686
687 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
688
689 $(RUN_IN_TEMPDIR): | stamp-directories
690
691 doc/html/index.html: ENABLE_MANPAGES =
692 doc/man-html/index.html: ENABLE_MANPAGES = 1
693 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
694
695 # Note: we use here an order-only prerequisite, as the contents of
696 # _autoconf.py are not actually influencing the html build output: it
697 # has to exist in order for the sphinx module to be loaded
698 # successfully, but we certainly don't want the docs to be rebuilt if
699 # it changes
700 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
701         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
702         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
703         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
704         | $(BUILT_PYTHON_SOURCES)
705         @test -n "$(SPHINX)" || \
706             { echo 'sphinx-build' not found during configure; exit 1; }
707 if !MANPAGES_IN_DOC
708         if test -n '$(ENABLE_MANPAGES)'; then \
709           echo 'Man pages in documentation were disabled at configure time' >&2; \
710           exit 1; \
711         fi
712 endif
713 ## Sphinx provides little control over what content should be included. Some
714 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
715 ## build two different versions of the documentation--once without man pages and
716 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
717 ## us with this, but requires running in a temporary directory. It moves the
718 ## correct files into place depending on environment variables.
719         dir=$(dir $@) && \
720         @mkdir_p@ $$dir && \
721         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
722         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
723             -d . \
724             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
725             -D release="$(PACKAGE_VERSION)" \
726             -D graphviz_dot="$(DOT)" \
727             -D enable_manpages="$(ENABLE_MANPAGES)" \
728             doc $(CURDIR)/$$dir && \
729         rm -f $$dir/.buildinfo $$dir/objects.inv
730         touch $@
731
732 doc/html: doc/html/index.html
733
734 doc/man-html: doc/man-html/index.html
735
736 doc/install-quick.rst: INSTALL
737 doc/news.rst: NEWS
738 doc/upgrade.rst: UPGRADE
739
740 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
741         set -e; \
742         { echo '.. This file is automatically updated at build time from $<.'; \
743           echo '.. Do not edit.'; \
744           echo; \
745           cat $<; \
746         } > $@
747
748 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
749         { echo '.. This file is automatically generated, do not edit!'; \
750           echo ''; \
751           echo 'Man pages'; \
752           echo '========='; \
753           echo; \
754           echo '.. toctree::'; \
755           echo '   :maxdepth: 1'; \
756           echo; \
757           for i in $(notdir $(mandocrst)); do \
758             echo "   $$i"; \
759           done | LC_ALL=C sort; \
760         } > $@
761
762 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
763 if MANPAGES_IN_DOC
764         { echo '.. This file is automatically updated at build time from $<.'; \
765           echo '.. Do not edit.'; \
766           echo; \
767           echo "$*"; \
768           echo '=========================================='; \
769           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
770         } > $@
771 else
772         echo 'Man pages in documentation were disabled at configure time' >&2; \
773         exit 1;
774 endif
775
776 # Things to build but not to install (add it to EXTRA_DIST if it should be
777 # distributed)
778 noinst_DATA = \
779         doc/html \
780         $(BUILT_EXAMPLES) \
781         doc/examples/bash_completion \
782         doc/examples/bash_completion-debug \
783         $(manhtml)
784
785 if MANPAGES_IN_DOC
786 noinst_DATA += doc/man-html
787 endif
788
789 gnt_scripts = \
790         scripts/gnt-backup \
791         scripts/gnt-cluster \
792         scripts/gnt-debug \
793         scripts/gnt-group \
794         scripts/gnt-instance \
795         scripts/gnt-job \
796         scripts/gnt-network \
797         scripts/gnt-node \
798         scripts/gnt-os \
799         scripts/gnt-storage
800
801 PYTHON_BOOTSTRAP_SBIN = \
802         daemons/ganeti-masterd \
803         daemons/ganeti-noded \
804         daemons/ganeti-rapi \
805         daemons/ganeti-watcher \
806         $(gnt_scripts)
807
808 PYTHON_BOOTSTRAP = \
809         $(PYTHON_BOOTSTRAP_SBIN) \
810         tools/burnin \
811         tools/ensure-dirs \
812         tools/node-cleanup \
813         tools/node-daemon-setup \
814         tools/prepare-node-join
815
816 qa_scripts = \
817         qa/__init__.py \
818         qa/ganeti-qa.py \
819         qa/qa_cluster.py \
820         qa/qa_config.py \
821         qa/qa_daemon.py \
822         qa/qa_env.py \
823         qa/qa_error.py \
824         qa/qa_group.py \
825         qa/qa_instance.py \
826         qa/qa_instance_utils.py \
827         qa/qa_job.py \
828         qa/qa_monitoring.py \
829         qa/qa_node.py \
830         qa/qa_os.py \
831         qa/qa_rapi.py \
832         qa/qa_tags.py \
833         qa/qa_utils.py
834
835 bin_SCRIPTS =
836 if WANT_HTOOLS
837 bin_SCRIPTS += $(HS_BIN_PROGS)
838 install-exec-hook:
839         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
840 # FIXME: this is a hardcoded logic, instead of auto-resolving
841         $(LN_S) -f ../../../bin/htools \
842           $(DESTDIR)$(iallocatorsdir)/hail
843         for role in $(HS_BIN_ROLES); do \
844           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
845         done
846 endif
847
848 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
849         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
850           echo "Error: cannot run unittests without the development" \
851                " libraries (see devnotes.rst)" 1>&2; \
852           exit 1; \
853         fi
854         @rm -f $(notdir $@).tix
855         $(GHC) --make \
856           $(HFLAGS) \
857           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
858           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
859           $(HEXTRA) $(HEXTRA_INT) $@
860         @touch "$@"
861
862 # for the test/hs/htest binary, we need to enable profiling/coverage
863 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
864
865 # we compile the hpc-htools binary with the program coverage
866 test/hs/hpc-htools: HEXTRA_INT=-fhpc
867
868 # we compile the hpc-mon-collector binary with the program coverage
869 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
870
871 # test dependency
872 test/hs/offline-test.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
873
874 # rules for building profiling-enabled versions of the haskell
875 # programs: hs-prof does the full two-step build, whereas
876 # hs-prof-quick does only the final rebuild (hs-prof must have been
877 # run before)
878 .PHONY: hs-prof hs-prof-quick
879 hs-prof:
880         @if [ -z "$(TARGET)" ]; then \
881           echo "You need to define TARGET when running this rule" 1>&2; \
882           exit 1; \
883         fi
884         $(MAKE) $(AM_MAKEFLAGS) clean
885         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
886         rm -f $(HS_ALL_PROGS)
887         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
888
889 hs-prof-quick:
890         @if [ -z "$(TARGET)" ]; then \
891           echo "You need to define TARGET when running this rule" 1>&2; \
892           exit 1; \
893         fi
894         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
895
896 dist_sbin_SCRIPTS = \
897         tools/ganeti-listrunner
898
899 nodist_sbin_SCRIPTS = \
900         $(PYTHON_BOOTSTRAP_SBIN) \
901         daemons/ganeti-cleaner
902
903 if ENABLE_CONFD
904 src/ganeti-confd: src/hconfd
905         cp -f $< $@
906
907 nodist_sbin_SCRIPTS += src/ganeti-confd
908 endif
909
910 if ENABLE_MOND
911 nodist_sbin_SCRIPTS += src/ganeti-mond
912 endif
913
914 python_scripts = \
915         tools/cfgshell \
916         tools/cfgupgrade \
917         tools/cfgupgrade12 \
918         tools/cluster-merge \
919         tools/confd-client \
920         tools/fmtjson \
921         tools/lvmstrap \
922         tools/move-instance \
923         tools/ovfconverter \
924         tools/sanitize-config
925
926 dist_tools_SCRIPTS = \
927         $(python_scripts) \
928         tools/burnin \
929         tools/kvm-console-wrapper \
930         tools/master-ip-setup \
931         tools/xen-console-wrapper
932
933 nodist_tools_python_scripts = \
934         tools/node-cleanup
935
936 nodist_tools_SCRIPTS = \
937         $(nodist_tools_python_scripts) \
938         tools/users-setup \
939         tools/vcluster-setup
940
941 pkglib_python_scripts = \
942         daemons/import-export \
943         tools/check-cert-expired
944
945 nodist_pkglib_python_scripts = \
946         tools/ensure-dirs \
947         tools/node-daemon-setup \
948         tools/prepare-node-join
949
950 myexeclib_SCRIPTS = \
951         daemons/daemon-util \
952         tools/kvm-ifup \
953         tools/vif-ganeti \
954         tools/net-common \
955         $(pkglib_python_scripts) \
956         $(HS_MYEXECLIB_PROGS)
957
958 nodist_myexeclib_SCRIPTS = \
959         $(nodist_pkglib_python_scripts)
960
961 EXTRA_DIST = \
962         NEWS \
963         UPGRADE \
964         epydoc.conf.in \
965         pylintrc \
966         autotools/build-bash-completion \
967         autotools/build-rpc \
968         autotools/check-header \
969         autotools/check-imports \
970         autotools/check-man-dashes \
971         autotools/check-man-references \
972         autotools/check-man-warnings \
973         autotools/check-news \
974         autotools/check-python-code \
975         autotools/check-tar \
976         autotools/check-version \
977         autotools/convert-constants \
978         autotools/docpp \
979         autotools/gen-py-coverage \
980         autotools/sphinx-wrapper \
981         autotools/testrunner \
982         autotools/wrong-hardcoded-paths \
983         $(RUN_IN_TEMPDIR) \
984         daemons/daemon-util.in \
985         daemons/ganeti-cleaner.in \
986         $(pkglib_python_scripts) \
987         devel/upload \
988         devel/webserver \
989         tools/kvm-ifup.in \
990         tools/vif-ganeti.in \
991         tools/net-common.in \
992         tools/users-setup.in \
993         tools/vcluster-setup.in \
994         $(docinput) \
995         doc/html \
996         $(BUILT_EXAMPLES:%=%.in) \
997         doc/examples/ganeti.default \
998         doc/examples/ganeti.default-debug \
999         doc/examples/hooks/ethers \
1000         doc/examples/gnt-debug/README \
1001         doc/examples/gnt-debug/delay0.json \
1002         doc/examples/gnt-debug/delay50.json \
1003         test/py/lockperf.py \
1004         test/py/testutils.py \
1005         test/py/mocks.py \
1006         $(dist_TESTS) \
1007         $(TEST_FILES) \
1008         man/footer.rst \
1009         $(manrst) \
1010         $(maninput) \
1011         qa/qa-sample.json \
1012         $(qa_scripts) \
1013         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
1014         $(HS_PROG_SRCS) \
1015         src/lint-hints.hs \
1016         test/hs/cli-tests-defs.sh \
1017         test/hs/offline-test.sh \
1018         .ghci
1019
1020 man_MANS = \
1021         man/ganeti-cleaner.8 \
1022         man/ganeti-confd.8 \
1023         man/ganeti-listrunner.8 \
1024         man/ganeti-masterd.8 \
1025         man/ganeti-mond.8 \
1026         man/ganeti-noded.8 \
1027         man/ganeti-os-interface.7 \
1028         man/ganeti-extstorage-interface.7 \
1029         man/ganeti-rapi.8 \
1030         man/ganeti-watcher.8 \
1031         man/ganeti.7 \
1032         man/gnt-backup.8 \
1033         man/gnt-cluster.8 \
1034         man/gnt-debug.8 \
1035         man/gnt-group.8 \
1036         man/gnt-network.8 \
1037         man/gnt-instance.8 \
1038         man/gnt-job.8 \
1039         man/gnt-node.8 \
1040         man/gnt-os.8 \
1041         man/gnt-storage.8 \
1042         man/hail.1 \
1043         man/harep.1 \
1044         man/hbal.1 \
1045         man/hcheck.1 \
1046         man/hinfo.1 \
1047         man/hscan.1 \
1048         man/hspace.1 \
1049         man/hroller.1 \
1050         man/htools.1 \
1051         man/mon-collector.7
1052
1053 # Remove extensions from all filenames in man_MANS
1054 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1055
1056 manrst = $(patsubst %,%.rst,$(mannoext))
1057 manhtml = $(patsubst %.rst,%.html,$(manrst))
1058 mangen = $(patsubst %.rst,%.gen,$(manrst))
1059 maninput = \
1060         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1061         $(patsubst %.html,%.html.in,$(manhtml)) \
1062         $(mangen)
1063
1064 TEST_FILES = \
1065         test/autotools/autotools-check-news.test \
1066         test/data/htools/clean-nonzero-score.data \
1067         test/data/htools/common-suffix.data \
1068         test/data/htools/empty-cluster.data \
1069         test/data/htools/hail-alloc-drbd.json \
1070         test/data/htools/hail-alloc-invalid-network.json \
1071         test/data/htools/hail-alloc-invalid-twodisks.json \
1072         test/data/htools/hail-alloc-restricted-network.json \
1073         test/data/htools/hail-alloc-spindles.json \
1074         test/data/htools/hail-alloc-twodisks.json \
1075         test/data/htools/hail-change-group.json \
1076         test/data/htools/hail-invalid-reloc.json \
1077         test/data/htools/hail-node-evac.json \
1078         test/data/htools/hail-reloc-drbd.json \
1079         test/data/htools/hbal-excl-tags.data \
1080         test/data/htools/hbal-split-insts.data \
1081         test/data/htools/hspace-tiered-dualspec-exclusive.data \
1082         test/data/htools/hspace-tiered-dualspec.data \
1083         test/data/htools/hspace-tiered-exclusive.data \
1084         test/data/htools/hspace-tiered-ipolicy.data \
1085         test/data/htools/hspace-tiered-mixed.data \
1086         test/data/htools/hspace-tiered-resourcetypes.data \
1087         test/data/htools/hspace-tiered-vcpu.data \
1088         test/data/htools/hspace-tiered.data \
1089         test/data/htools/invalid-node.data \
1090         test/data/htools/missing-resources.data \
1091         test/data/htools/multiple-master.data \
1092         test/data/htools/multiple-tags.data \
1093         test/data/htools/n1-failure.data \
1094         test/data/htools/rapi/groups.json \
1095         test/data/htools/rapi/info.json \
1096         test/data/htools/rapi/instances.json \
1097         test/data/htools/rapi/nodes.json \
1098         test/data/htools/hroller-full.data \
1099         test/data/htools/hroller-nodegroups.data \
1100         test/data/htools/hroller-nonredundant.data \
1101         test/data/htools/hroller-online.data \
1102         test/data/htools/unique-reboot-order.data \
1103         test/hs/shelltests/htools-balancing.test \
1104         test/hs/shelltests/htools-basic.test \
1105         test/hs/shelltests/htools-dynutil.test \
1106         test/hs/shelltests/htools-excl.test \
1107         test/hs/shelltests/htools-hail.test \
1108         test/hs/shelltests/htools-hroller.test \
1109         test/hs/shelltests/htools-hspace.test \
1110         test/hs/shelltests/htools-invalid.test \
1111         test/hs/shelltests/htools-multi-group.test \
1112         test/hs/shelltests/htools-no-backend.test \
1113         test/hs/shelltests/htools-rapi.test \
1114         test/hs/shelltests/htools-single-group.test \
1115         test/hs/shelltests/htools-text-backend.test \
1116         test/hs/shelltests/htools-mon-collector.test \
1117         test/data/bdev-drbd-8.0.txt \
1118         test/data/bdev-drbd-8.3.txt \
1119         test/data/bdev-drbd-8.4.txt \
1120         test/data/bdev-drbd-disk.txt \
1121         test/data/bdev-drbd-net-ip4.txt \
1122         test/data/bdev-drbd-net-ip6.txt \
1123         test/data/bdev-rbd/json_output_empty.txt \
1124         test/data/bdev-rbd/json_output_extra_matches.txt \
1125         test/data/bdev-rbd/json_output_no_matches.txt \
1126         test/data/bdev-rbd/json_output_ok.txt \
1127         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1128         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1129         test/data/bdev-rbd/plain_output_new_ok.txt \
1130         test/data/bdev-rbd/plain_output_old_empty.txt \
1131         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1132         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1133         test/data/bdev-rbd/plain_output_old_ok.txt \
1134         test/data/bdev-rbd/output_invalid.txt \
1135         test/data/cert1.pem \
1136         test/data/cert2.pem \
1137         test/data/cluster_config_2.7.json \
1138         test/data/cluster_config_2.8.json \
1139         test/data/instance-minor-pairing.txt \
1140         test/data/instance-prim-sec.txt \
1141         test/data/ip-addr-show-dummy0.txt \
1142         test/data/ip-addr-show-lo-ipv4.txt \
1143         test/data/ip-addr-show-lo-ipv6.txt \
1144         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1145         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1146         test/data/ip-addr-show-lo-oneline.txt \
1147         test/data/ip-addr-show-lo.txt \
1148         test/data/kvm_0.12.5_help.txt \
1149         test/data/kvm_0.15.90_help.txt \
1150         test/data/kvm_0.9.1_help.txt \
1151         test/data/kvm_0.9.1_help_boot_test.txt \
1152         test/data/kvm_1.0_help.txt \
1153         test/data/kvm_1.1.2_help.txt \
1154         test/data/lvs_lv.txt \
1155         test/data/NEWS_OK.txt \
1156         test/data/NEWS_previous_unreleased.txt \
1157         test/data/ovfdata/compr_disk.vmdk.gz \
1158         test/data/ovfdata/config.ini \
1159         test/data/ovfdata/corrupted_resources.ovf \
1160         test/data/ovfdata/empty.ini \
1161         test/data/ovfdata/empty.ovf \
1162         test/data/ovfdata/ganeti.mf \
1163         test/data/ovfdata/ganeti.ovf \
1164         test/data/ovfdata/gzip_disk.ovf \
1165         test/data/ovfdata/new_disk.vmdk \
1166         test/data/ovfdata/no_disk.ini \
1167         test/data/ovfdata/no_disk_in_ref.ovf \
1168         test/data/ovfdata/no_os.ini \
1169         test/data/ovfdata/no_ovf.ova \
1170         test/data/ovfdata/other/rawdisk.raw \
1171         test/data/ovfdata/ova.ova \
1172         test/data/ovfdata/rawdisk.raw \
1173         test/data/ovfdata/second_disk.vmdk \
1174         test/data/ovfdata/unsafe_path.ini \
1175         test/data/ovfdata/virtualbox.ovf \
1176         test/data/ovfdata/wrong_config.ini \
1177         test/data/ovfdata/wrong_extension.ovd \
1178         test/data/ovfdata/wrong_manifest.mf \
1179         test/data/ovfdata/wrong_manifest.ovf \
1180         test/data/ovfdata/wrong_ova.ova \
1181         test/data/ovfdata/wrong_xml.ovf \
1182         test/data/proc_diskstats.txt \
1183         test/data/proc_drbd8.txt \
1184         test/data/proc_drbd80-emptyline.txt \
1185         test/data/proc_drbd80-emptyversion.txt \
1186         test/data/proc_drbd83.txt \
1187         test/data/proc_drbd83_sync.txt \
1188         test/data/proc_drbd83_sync_want.txt \
1189         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1190         test/data/proc_drbd84.txt \
1191         test/data/proc_drbd84_sync.txt \
1192         test/data/qa-minimal-nodes-instances-only.json \
1193         test/data/sys_drbd_usermode_helper.txt \
1194         test/data/vgreduce-removemissing-2.02.02.txt \
1195         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1196         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1197         test/data/vgs-missing-pvs-2.02.02.txt \
1198         test/data/vgs-missing-pvs-2.02.66.txt \
1199         test/data/xen-xm-info-4.0.1.txt \
1200         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1201         test/data/xen-xm-list-4.0.1-four-instances.txt \
1202         test/data/xen-xm-list-long-4.0.1.txt \
1203         test/data/xen-xm-uptime-4.0.1.txt \
1204         test/py/ganeti-cli.test \
1205         test/py/gnt-cli.test \
1206         test/py/import-export_unittest-helper
1207
1208
1209 python_tests = \
1210         doc/examples/rapi_testutils.py \
1211         test/py/cfgupgrade_unittest.py \
1212         test/py/docs_unittest.py \
1213         test/py/ganeti.asyncnotifier_unittest.py \
1214         test/py/ganeti.backend_unittest-runasroot.py \
1215         test/py/ganeti.backend_unittest.py \
1216         test/py/ganeti.bootstrap_unittest.py \
1217         test/py/ganeti.cli_unittest.py \
1218         test/py/ganeti.client.gnt_cluster_unittest.py \
1219         test/py/ganeti.client.gnt_instance_unittest.py \
1220         test/py/ganeti.client.gnt_job_unittest.py \
1221         test/py/ganeti.cmdlib_unittest.py \
1222         test/py/ganeti.compat_unittest.py \
1223         test/py/ganeti.confd.client_unittest.py \
1224         test/py/ganeti.config_unittest.py \
1225         test/py/ganeti.constants_unittest.py \
1226         test/py/ganeti.daemon_unittest.py \
1227         test/py/ganeti.errors_unittest.py \
1228         test/py/ganeti.hooks_unittest.py \
1229         test/py/ganeti.ht_unittest.py \
1230         test/py/ganeti.http_unittest.py \
1231         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1232         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1233         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1234         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1235         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1236         test/py/ganeti.hypervisor_unittest.py \
1237         test/py/ganeti.impexpd_unittest.py \
1238         test/py/ganeti.jqueue_unittest.py \
1239         test/py/ganeti.jstore_unittest.py \
1240         test/py/ganeti.locking_unittest.py \
1241         test/py/ganeti.luxi_unittest.py \
1242         test/py/ganeti.masterd.iallocator_unittest.py \
1243         test/py/ganeti.masterd.instance_unittest.py \
1244         test/py/ganeti.mcpu_unittest.py \
1245         test/py/ganeti.netutils_unittest.py \
1246         test/py/ganeti.objects_unittest.py \
1247         test/py/ganeti.opcodes_unittest.py \
1248         test/py/ganeti.outils_unittest.py \
1249         test/py/ganeti.ovf_unittest.py \
1250         test/py/ganeti.qlang_unittest.py \
1251         test/py/ganeti.query_unittest.py \
1252         test/py/ganeti.rapi.baserlib_unittest.py \
1253         test/py/ganeti.rapi.client_unittest.py \
1254         test/py/ganeti.rapi.resources_unittest.py \
1255         test/py/ganeti.rapi.rlib2_unittest.py \
1256         test/py/ganeti.rapi.testutils_unittest.py \
1257         test/py/ganeti.rpc_unittest.py \
1258         test/py/ganeti.runtime_unittest.py \
1259         test/py/ganeti.serializer_unittest.py \
1260         test/py/ganeti.server.rapi_unittest.py \
1261         test/py/ganeti.ssconf_unittest.py \
1262         test/py/ganeti.ssh_unittest.py \
1263         test/py/ganeti.storage.bdev_unittest.py \
1264         test/py/ganeti.storage.container_unittest.py \
1265         test/py/ganeti.storage.drbd_unittest.py \
1266         test/py/ganeti.storage.filestorage_unittest.py \
1267         test/py/ganeti.tools.burnin_unittest.py \
1268         test/py/ganeti.tools.ensure_dirs_unittest.py \
1269         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1270         test/py/ganeti.tools.prepare_node_join_unittest.py \
1271         test/py/ganeti.uidpool_unittest.py \
1272         test/py/ganeti.utils.algo_unittest.py \
1273         test/py/ganeti.utils.filelock_unittest.py \
1274         test/py/ganeti.utils.hash_unittest.py \
1275         test/py/ganeti.utils.io_unittest-runasroot.py \
1276         test/py/ganeti.utils.io_unittest.py \
1277         test/py/ganeti.utils.log_unittest.py \
1278         test/py/ganeti.utils.lvm_unittest.py \
1279         test/py/ganeti.utils.mlock_unittest.py \
1280         test/py/ganeti.utils.nodesetup_unittest.py \
1281         test/py/ganeti.utils.process_unittest.py \
1282         test/py/ganeti.utils.retry_unittest.py \
1283         test/py/ganeti.utils.storage_unittest.py \
1284         test/py/ganeti.utils.text_unittest.py \
1285         test/py/ganeti.utils.wrapper_unittest.py \
1286         test/py/ganeti.utils.x509_unittest.py \
1287         test/py/ganeti.utils_unittest.py \
1288         test/py/ganeti.vcluster_unittest.py \
1289         test/py/ganeti.workerpool_unittest.py \
1290         test/py/pycurl_reset_unittest.py \
1291         test/py/qa.qa_config_unittest.py \
1292         test/py/tempfile_fork_unittest.py
1293
1294 haskell_tests = test/hs/htest
1295
1296 dist_TESTS = \
1297         test/py/check-cert-expired_unittest.bash \
1298         test/py/daemon-util_unittest.bash \
1299         test/py/ganeti-cleaner_unittest.bash \
1300         test/py/import-export_unittest.bash \
1301         test/py/cli-test.bash \
1302         test/py/bash_completion.bash
1303
1304 if !PY_NODEV
1305         dist_TESTS += $(python_tests)
1306 endif
1307
1308 nodist_TESTS =
1309 check_SCRIPTS =
1310
1311 if WANT_HSTESTS
1312 nodist_TESTS += $(haskell_tests)
1313 dist_TESTS += test/hs/offline-test.sh
1314 check_SCRIPTS += \
1315         test/hs/hpc-htools \
1316         test/hs/hpc-mon-collector \
1317         $(HS_BUILT_TEST_HELPERS)
1318 endif
1319
1320 TESTS = $(dist_TESTS) $(nodist_TESTS)
1321
1322 # Environment for all tests
1323 PLAIN_TESTS_ENVIRONMENT = \
1324         PYTHONPATH=. \
1325         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1326         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1327         $(RUN_IN_TEMPDIR)
1328
1329 # Environment for tests run by automake
1330 TESTS_ENVIRONMENT = \
1331         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1332
1333 all_python_code = \
1334         $(dist_sbin_SCRIPTS) \
1335         $(python_scripts) \
1336         $(pkglib_python_scripts) \
1337         $(nodist_pkglib_python_scripts) \
1338         $(nodist_tools_python_scripts) \
1339         $(pkgpython_PYTHON) \
1340         $(client_PYTHON) \
1341         $(cmdlib_PYTHON) \
1342         $(hypervisor_PYTHON) \
1343         $(storage_PYTHON) \
1344         $(rapi_PYTHON) \
1345         $(server_PYTHON) \
1346         $(pytools_PYTHON) \
1347         $(http_PYTHON) \
1348         $(confd_PYTHON) \
1349         $(masterd_PYTHON) \
1350         $(impexpd_PYTHON) \
1351         $(utils_PYTHON) \
1352         $(watcher_PYTHON) \
1353         $(noinst_PYTHON) \
1354         $(qa_scripts)
1355
1356 if !PY_NODEV
1357         all_python_code += $(python_tests)
1358 endif
1359
1360 srclink_files = \
1361         man/footer.rst \
1362         test/py/check-cert-expired_unittest.bash \
1363         test/py/daemon-util_unittest.bash \
1364         test/py/ganeti-cleaner_unittest.bash \
1365         test/py/import-export_unittest.bash \
1366         test/py/cli-test.bash \
1367         test/py/bash_completion.bash \
1368         test/hs/offline-test.sh \
1369         test/hs/cli-tests-defs.sh \
1370         $(all_python_code) \
1371         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1372         $(docinput)
1373
1374 check_python_code = \
1375         $(BUILD_BASH_COMPLETION) \
1376         $(CHECK_IMPORTS) \
1377         $(CHECK_HEADER) \
1378         $(DOCPP) \
1379         $(all_python_code)
1380
1381 lint_python_code = \
1382         ganeti \
1383         ganeti/http/server.py \
1384         $(dist_sbin_SCRIPTS) \
1385         $(python_scripts) \
1386         $(pkglib_python_scripts) \
1387         $(BUILD_BASH_COMPLETION) \
1388         $(CHECK_IMPORTS) \
1389         $(CHECK_HEADER) \
1390         $(DOCPP) \
1391         $(PYTHON_BOOTSTRAP)
1392
1393 standalone_python_modules = \
1394         lib/rapi/client.py \
1395         tools/ganeti-listrunner
1396
1397 pep8_python_code = \
1398         ganeti \
1399         ganeti/http/server.py \
1400         $(dist_sbin_SCRIPTS) \
1401         $(python_scripts) \
1402         $(pkglib_python_scripts) \
1403         $(BUILD_BASH_COMPLETION) \
1404         $(CHECK_HEADER) \
1405         $(DOCPP) \
1406         $(PYTHON_BOOTSTRAP) \
1407         qa
1408
1409 test/py/daemon-util_unittest.bash: daemons/daemon-util
1410
1411 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1412
1413 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1414
1415 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1416         sed -f $(REPLACE_VARS_SED) < $< > $@
1417         chmod +x $@
1418
1419 tools/vif-ganeti: tools/vif-ganeti.in $(REPLACE_VARS_SED)
1420         sed -f $(REPLACE_VARS_SED) < $< > $@
1421         chmod +x $@
1422
1423 tools/net-common: tools/net-common.in $(REPLACE_VARS_SED)
1424         sed -f $(REPLACE_VARS_SED) < $< > $@
1425         chmod +x $@
1426
1427 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1428         sed -f $(REPLACE_VARS_SED) < $< > $@
1429         chmod +x $@
1430
1431 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1432         sed -f $(REPLACE_VARS_SED) < $< > $@
1433         chmod +x $@
1434
1435 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1436         sed -f $(REPLACE_VARS_SED) < $< > $@
1437         chmod +x $@
1438
1439 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1440         sed -f $(REPLACE_VARS_SED) < $< > $@
1441
1442 doc/examples/bash_completion: BC_ARGS = --compact
1443 doc/examples/bash_completion-debug: BC_ARGS =
1444
1445 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1446         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1447         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1448         daemons/ganeti-cleaner \
1449         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1450         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1451           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1452
1453 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1454         lib/build/shell_example_lexer.py \
1455         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1456         @echo "Checking $< for hardcoded paths..."
1457         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1458           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1459           exit 1; \
1460         fi
1461         set -e ; \
1462         trap 'echo auto-removing $@; rm $@' EXIT; \
1463         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1464         $(CHECK_MAN_REFERENCES) $@; \
1465         trap - EXIT
1466
1467 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1468         @test -n "$(PANDOC)" || \
1469           { echo 'pandoc' not found during configure; exit 1; }
1470         set -o pipefail -e; \
1471         trap 'echo auto-removing $@; rm $@' EXIT; \
1472         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1473           sed -e 's/\\@/@/g' > $@; \
1474         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1475         $(CHECK_MAN_DASHES) $@; \
1476         trap - EXIT
1477
1478 man/%.html.in: man/%.gen man/footer.rst
1479         @test -n "$(PANDOC)" || \
1480           { echo 'pandoc' not found during configure; exit 1; }
1481         set -o pipefail ; \
1482         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1483           sed -e 's/\\@/@/g' > $@
1484
1485 man/%: man/%.in  $(REPLACE_VARS_SED)
1486         sed -f $(REPLACE_VARS_SED) < $< > $@
1487
1488 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1489         sed -f $(REPLACE_VARS_SED) < $< > $@
1490
1491 vcs-version:
1492         if test -d .git; then \
1493           git describe > $@; \
1494         elif test ! -f $@ ; then \
1495           echo "Cannot auto-generate $@ file"; exit 1; \
1496         fi
1497
1498 .PHONY: clean-vcs-version
1499 clean-vcs-version:
1500         rm -f vcs-version
1501
1502 .PHONY: regen-vcs-version
1503 regen-vcs-version:
1504         @set -e; \
1505         cd $(srcdir); \
1506         if test -d .git; then \
1507           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1508           git describe > $$T; \
1509           if ! cmp --quiet $$T vcs-version; then \
1510             mv $$T vcs-version; \
1511           fi; \
1512         fi
1513
1514 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1515         vcs-version $(built_base_sources)
1516         set -e; \
1517         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1518         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1519
1520 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1521         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1522         lib/jstore.py $(RUN_IN_TEMPDIR) \
1523         $(CONVERT_CONSTANTS) $(built_base_sources) \
1524         | lib/_vcsversion.py
1525         set -e; \
1526         { cat $< ; \
1527           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1528         } > $@
1529
1530 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1531         hsc2hs -o $@ $<
1532
1533 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1534         $(built_base_sources)
1535         set -e; \
1536         { cat $< ; \
1537           echo ; \
1538           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1539             echo "import $$name ()" ; \
1540           done ; \
1541         } > $@
1542
1543 lib/_autoconf.py: Makefile | stamp-directories
1544         set -e; \
1545         { echo '# This file is automatically generated, do not edit!'; \
1546           echo '#'; \
1547           echo ''; \
1548           echo '"""Build-time configuration for Ganeti.'; \
1549           echo '';\
1550           echo 'This file is autogenerated by the build process.'; \
1551           echo 'For any changes you need to re-run ./configure (and'; \
1552           echo 'not edit by hand).'; \
1553           echo ''; \
1554           echo '"""'; \
1555           echo ''; \
1556           echo '# pylint: disable=C0301,C0324'; \
1557           echo '# because this is autogenerated, we do not want'; \
1558           echo '# style warnings' ; \
1559           echo ''; \
1560           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1561           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1562           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1563           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1564           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1565           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1566           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1567           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1568           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1569           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1570           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1571           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1572           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1573           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1574           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1575           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1576           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1577           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1578           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1579           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1580           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1581           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1582           echo "KVM_PATH = '$(KVM_PATH)'"; \
1583           echo "IP_PATH = '$(IP_PATH)'"; \
1584           echo "SOCAT_PATH = '$(SOCAT)'"; \
1585           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1586           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1587           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1588           echo "TOOLSDIR = '$(toolsdir)'"; \
1589           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1590           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1591           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1592           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1593           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1594           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1595           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1596           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1597           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1598           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1599           echo "RAPI_USER = '$(RAPI_USER)'"; \
1600           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1601           echo "CONFD_USER = '$(CONFD_USER)'"; \
1602           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1603           echo "NODED_USER = '$(NODED_USER)'"; \
1604           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1605           echo "MOND_USER = '$(MOND_USER)'"; \
1606           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1607           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1608           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1609           echo "HTOOLS = True"; \
1610           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1611           echo "XEN_CMD = '$(XEN_CMD)'"; \
1612           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1613           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1614           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1615 ## Write dictionary with man page name as the key and the section number as the
1616 ## value
1617           echo "MAN_PAGES = {"; \
1618           for i in $(notdir $(man_MANS)); do \
1619             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1620           done; \
1621           echo "}"; \
1622         } > $@
1623
1624 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1625         set -e; \
1626         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1627         { echo '# This file is automatically generated, do not edit!'; \
1628           echo '#'; \
1629           echo ''; \
1630           echo '"""Build-time VCS version number for Ganeti.'; \
1631           echo '';\
1632           echo 'This file is autogenerated by the build process.'; \
1633           echo 'For any changes you need to re-run ./configure (and'; \
1634           echo 'not edit by hand).'; \
1635           echo ''; \
1636           echo '"""'; \
1637           echo ''; \
1638           echo '# pylint: disable=C0301,C0324'; \
1639           echo '# because this is autogenerated, we do not want'; \
1640           echo '# style warnings' ; \
1641           echo ''; \
1642           echo "VCS_VERSION = '$$VCSVER'"; \
1643         } > $@
1644
1645 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1646         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1647
1648 $(SHELL_ENV_INIT): Makefile stamp-directories
1649         set -e; \
1650         { echo '# Allow overriding for tests'; \
1651           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1652           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1653           echo; \
1654           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1655           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1656           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1657           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1658           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1659         } > $@
1660
1661 ## Writes sed script to replace placeholders with build-time values. The
1662 ## additional quotes after the first @ sign are necessary to stop configure
1663 ## from replacing those values as well.
1664 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1665         set -e; \
1666         { echo 's#@''PREFIX@#$(prefix)#g'; \
1667           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1668           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1669           echo 's#@''BINDIR@#$(bindir)#g'; \
1670           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1671           echo 's#@''LIBDIR@#$(libdir)#g'; \
1672           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1673           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1674           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1675           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1676           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1677           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1678           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1679           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1680           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1681           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1682           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1683           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1684           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1685           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1686           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1687           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1688           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1689           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1690           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1691           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1692           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1693           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1694           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1695           echo; \
1696           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1697           echo '  r $(SHELL_ENV_INIT)'; \
1698           echo '  d'; \
1699           echo '}'; \
1700         } > $@
1701
1702 # Using deferred evaluation
1703 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1704 daemons/ganeti-watcher: MODULE = ganeti.watcher
1705 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1706 tools/burnin: MODULE = ganeti.tools.burnin
1707 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1708 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1709 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1710 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1711 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1712
1713 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1714         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1715         set -e; \
1716         { echo '#!/usr/bin/python'; \
1717           echo '# This file is automatically generated, do not edit!'; \
1718           echo "# Edit $(MODULE) instead."; \
1719           echo; \
1720           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1721           echo; \
1722           echo '# pylint: disable=C0103'; \
1723           echo '# C0103: Invalid name'; \
1724           echo; \
1725           echo 'import sys'; \
1726           echo 'import $(MODULE) as main'; \
1727           echo; \
1728           echo '# Temporarily alias commands until bash completion'; \
1729           echo '# generator is changed'; \
1730           echo 'if hasattr(main, "commands"):'; \
1731           echo '  commands = main.commands # pylint: disable=E1101'; \
1732           echo 'if hasattr(main, "aliases"):'; \
1733           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1734           echo; \
1735           echo 'if __name__ == "__main__":'; \
1736           echo '  sys.exit(main.Main())'; \
1737         } > $@
1738         chmod u+x $@
1739
1740 $(HS_BUILT_TEST_HELPERS): Makefile
1741         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1742         set -e; \
1743         { echo '#!/bin/sh'; \
1744           echo '# This file is automatically generated, do not edit!'; \
1745           echo "# Edit Makefile.am instead."; \
1746           echo; \
1747           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1748         } > $@
1749         chmod u+x $@
1750
1751 stamp-directories: Makefile
1752         $(MAKE) $(AM_MAKEFLAGS) ganeti
1753         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1754         touch $@
1755
1756 # We need to create symlinks because "make distcheck" will not install Python
1757 # files when building.
1758 stamp-srclinks: Makefile | stamp-directories
1759         set -e; \
1760         for i in $(srclink_files); do \
1761           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1762             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1763           fi; \
1764         done
1765         touch $@
1766
1767 .PHONY: ganeti
1768 ganeti:
1769         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1770
1771 .PHONY: check-dirs
1772 check-dirs: $(GENERATED_FILES)
1773         @set -e; \
1774         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1775           error=; \
1776           while read dir; do \
1777             case "$$dir" in \
1778               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1779               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1780             esac; \
1781           done; \
1782           for dir in $(DIRS); do \
1783             if ! test -d "$$dir"; then \
1784               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1785               error=1; \
1786             fi \
1787           done; \
1788           test -z "$$error"; \
1789         }
1790
1791 .PHONY: check-local
1792 check-local: check-dirs $(GENERATED_FILES)
1793         $(CHECK_PYTHON_CODE) $(check_python_code)
1794         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1795         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1796         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1797         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1798         error= ; \
1799         if [ "x`echo $(VERSION_SUFFIX)|grep 'alpha'`" == "x" ]; then \
1800           expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1801           if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1802             echo "Incorrect version in README, expected $$expver" >&2; \
1803             error=1; \
1804           fi; \
1805           for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1806               doc/security.rst; do \
1807             if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1808               "Documents Ganeti version $$expver"; then \
1809               echo "Incorrect version in $$file, expected $$expver" >&2; \
1810               error=1; \
1811             fi; \
1812           done; \
1813           if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1814             echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1815             error=1; \
1816           fi; \
1817           if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1818             ".. Last updated for Ganeti $$expver"; then \
1819             echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1820             error=1; \
1821           fi; \
1822         fi; \
1823         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1824           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1825             echo "Longest line in $$file is longer than 80 characters" >&2; \
1826             error=1; \
1827           fi; \
1828         done; \
1829         test -z "$$error"
1830
1831 .PHONY: hs-test-%
1832 hs-test-%: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1833         @rm -f htest.tix
1834         test/hs/htest -t $*
1835
1836 .PHONY: hs-tests
1837 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1838         @rm -f htest.tix
1839         ./test/hs/htest
1840
1841 .PHONY: hs-shell-%
1842 hs-shell-%: test/hs/hpc-htools test/hs/hpc-mon-collector \
1843             $(HS_BUILT_TEST_HELPERS)
1844         @rm -f hpc-htools.tix hpc-mon-collector.tix
1845         HBINARY="./test/hs/hpc-htools" \
1846         SHELLTESTARGS=$(SHELLTESTARGS) \
1847         ./test/hs/offline-test.sh $*
1848
1849 .PHONY: hs-shell
1850 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1851         @rm -f hpc-htools.tix hpc-mon-collector.tix
1852         HBINARY="./test/hs/hpc-htools" \
1853         SHELLTESTARGS=$(SHELLTESTARGS) \
1854         ./test/hs/offline-test.sh
1855
1856 .PHONY: hs-check
1857 hs-check: hs-tests hs-shell
1858
1859 # E111: indentation is not a multiple of four
1860 # E121: continuation line indentation is not a multiple of four
1861 #       (since our indent level is not 4)
1862 # E125: continuation line does not distinguish itself from next logical line
1863 #       (since our indent level is not 4)
1864 # E127: continuation line over-indented for visual indent
1865 #       (since our indent level is not 4)
1866 # note: do NOT add E128 here; it's a valid style error in most cases!
1867 # I've seen real errors, but also some cases were we indent wrongly
1868 # due to line length; try to rework the cases where it is triggered,
1869 # instead of silencing it
1870 # E261: at least two spaces before inline comment
1871 # E501: line too long (80 characters)
1872 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1873
1874 # For excluding pep8 expects filenames only, not whole paths
1875 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1876
1877 LINT_TARGETS = pylint pylint-qa
1878 if HAS_PEP8
1879 LINT_TARGETS += pep8
1880 endif
1881 if HAS_HLINT
1882 LINT_TARGETS += hlint
1883 endif
1884
1885 .PHONY: lint
1886 lint: $(LINT_TARGETS)
1887
1888 .PHONY: pylint
1889 pylint: $(GENERATED_FILES)
1890         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1891         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1892
1893 .PHONY: pylint-qa
1894 pylint-qa: $(GENERATED_FILES)
1895         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1896         cd $(top_srcdir)/qa && \
1897           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1898           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1899
1900 .PHONY: pep8
1901 pep8: $(GENERATED_FILES)
1902         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1903         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1904           --repeat $(pep8_python_code)
1905
1906 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1907 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1908 .PHONY: hlint
1909 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1910         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1911         @rm -f doc/hs-lint.html
1912         if tty -s; then C="-c"; else C=""; fi; \
1913         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1914           --ignore "Use first" \
1915           --ignore "Use &&&" \
1916           --ignore "Use void" \
1917           --ignore "Reduce duplication" \
1918           --hint src/lint-hints \
1919           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1920         @if [ ! -f doc/hs-lint.html ]; then \
1921           echo "All good" > doc/hs-lint.html; \
1922         fi
1923
1924 # a dist hook rule for updating the vcs-version file; this is
1925 # hardcoded due to where it needs to build the file...
1926 dist-hook:
1927         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1928         rm -f $(top_distdir)/vcs-version
1929         cp -p $(srcdir)/vcs-version $(top_distdir)
1930
1931 # a distcheck hook rule for catching revision control directories
1932 distcheck-hook:
1933         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1934           echo "Found revision control files in final archive." 1>&2; \
1935           exit 1; \
1936         fi
1937         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1938           echo "Found Python byte code in final archive." 1>&2; \
1939           exit 1; \
1940         fi
1941         if find $(top_distdir) -name '*~' | grep .; then \
1942           echo "Found backup files in final archive." 1>&2; \
1943           exit 1; \
1944         fi
1945 # Empty files or directories should not be distributed. They can cause
1946 # unnecessary warnings for packagers. Directories used by automake during
1947 # distcheck must be excluded.
1948         if find $(top_distdir) -empty -and -not \( \
1949             -path $(top_distdir)/_build -or \
1950             -path $(top_distdir)/_inst \) | grep .; then \
1951           echo "Found empty files or directories in final archive." 1>&2; \
1952           exit 1; \
1953         fi
1954         if test -e $(top_distdir)/doc/man-html; then \
1955           echo "Found documentation including man pages in final archive" >&2; \
1956           exit 1; \
1957         fi
1958
1959 # Backwards compatible distcheck-release target
1960 distcheck-release: distcheck
1961
1962 distrebuildcheck: dist
1963         set -e; \
1964         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1965         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1966         cd $$builddir; \
1967         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1968         cd $(distdir); \
1969         ./configure; \
1970         $(MAKE) maintainer-clean; \
1971         cp $(abs_srcdir)/vcs-version .; \
1972         ./configure; \
1973         $(MAKE) $(AM_MAKEFLAGS)
1974
1975 dist-release: dist
1976         set -e; \
1977         for i in $(DIST_ARCHIVES); do \
1978           echo -n "Checking $$i ... "; \
1979           autotools/check-tar < $$i; \
1980           echo OK; \
1981         done
1982
1983 install-exec-local:
1984         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1985           "$(DESTDIR)${localstatedir}/log/ganeti" \
1986           "$(DESTDIR)${localstatedir}/run/ganeti"
1987
1988 .PHONY: apidoc
1989 if WANT_HSAPIDOC
1990 apidoc: py-apidoc hs-apidoc
1991 else
1992 apidoc: py-apidoc
1993 endif
1994
1995 .PHONY: py-apidoc
1996 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1997         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1998         $(RUN_IN_TEMPDIR) epydoc -v \
1999           --conf $(CURDIR)/epydoc.conf \
2000           --output $(CURDIR)/$(APIDOC_PY_DIR)
2001
2002 .PHONY: hs-apidoc
2003 hs-apidoc: $(APIDOC_HS_DIR)/index.html
2004
2005 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
2006         @test -n "$(HSCOLOUR)" || \
2007             { echo 'HsColour' not found during configure; exit 1; }
2008         @test -n "$(HADDOCK)" || \
2009             { echo 'haddock' not found during configure; exit 1; }
2010         rm -rf $(APIDOC_HS_DIR)/*
2011         for i in $(ALL_APIDOC_HS_DIRS); do \
2012           @mkdir_p@ $$i; \
2013           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
2014         done
2015         set -e ; \
2016         export LC_ALL=en_US.UTF-8; \
2017         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
2018         if [ "$(HS_PARALLEL3)" ]; \
2019         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
2020         fi; \
2021         if [ "$(HS_REGEX_PCRE)" ]; \
2022         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
2023         fi; \
2024         for file in $(HS_LIBTESTBUILT_SRCS); do \
2025           f_nosrc=$${file##src/}; \
2026           f_notst=$${f_nosrc##test/hs/}; \
2027           f_html=$${f_notst%%.hs}.html; \
2028           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
2029         done ; \
2030         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
2031           -t ganeti -p src/haddock-prologue \
2032           --source-module="%{MODULE/.//}.html" \
2033           --source-entity="%{MODULE/.//}.html#%{NAME}" \
2034           $$OPTGHC \
2035           $(HS_LIBTESTBUILT_SRCS)
2036
2037 .PHONY: TAGS
2038 TAGS: $(GENERATED_FILES)
2039         rm -f TAGS
2040         $(GHC) -e ":etags" -v0 \
2041           $(filter-out -O -Werror,$(HFLAGS)) \
2042           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
2043           $(HS_LIBTEST_SRCS)
2044         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
2045           -path './daemons/ganeti-*' -o -path './tools/*' -o \
2046           -path './qa/*.py' | \
2047           etags -l python -a -
2048
2049 .PHONY: coverage
2050
2051 COVERAGE_TESTS=
2052 if WANT_HTOOLS
2053 COVERAGE_TESTS += hs-coverage
2054 endif
2055 if !PY_NODEV
2056 COVERAGE_TESTS += py-coverage
2057 endif
2058
2059 coverage: $(COVERAGE_TESTS)
2060
2061 .PHONY: py-coverage
2062 py-coverage: $(GENERATED_FILES) $(python_tests)
2063         @test -n "$(PYCOVERAGE)" || \
2064             { echo 'python-coverage' not found during configure; exit 1; }
2065         set -e; \
2066         COVERAGE=$(PYCOVERAGE) \
2067         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
2068         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
2069         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
2070         $(PLAIN_TESTS_ENVIRONMENT) \
2071         $(abs_top_srcdir)/autotools/gen-py-coverage \
2072         $(python_tests)
2073
2074 .PHONY: hs-coverage
2075 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
2076         rm -f *.tix
2077         $(MAKE) $(AM_MAKEFLAGS) hs-check
2078         @mkdir_p@ $(COVERAGE_HS_DIR)
2079         hpc sum --union $(HPCEXCL) \
2080           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
2081         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
2082         hpc report coverage-hs.tix
2083         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
2084
2085 # Special "kind-of-QA" target for htools, needs special setup (all
2086 # tools compiled with -fhpc)
2087 .PHONY: live-test
2088 live-test: all
2089         set -e ; \
2090         cd src; \
2091         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
2092         rm -f *.tix *.mix; \
2093         ./live-test.sh; \
2094         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
2095           --output=live-test.tix ; \
2096         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
2097         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
2098           --srcdir=.. $(HPCEXCL) ; \
2099         hpc report --srcdir=.. live-test $(HPCEXCL)
2100
2101 commit-check: autotools-check distcheck lint apidoc
2102
2103 autotools-check:
2104         TESTDATA_DIR=./test/data shelltest $(SHELLTESTARGS) \
2105   $(abs_top_srcdir)/test/autotools/*-*.test \
2106   -- --hide-successes
2107
2108 .PHONY: gitignore-check
2109 gitignore-check:
2110         @if [ -n "`git status --short`" ]; then \
2111           echo "Git status is not clean!" 1>&2 ; \
2112           git status --short; \
2113           exit 1; \
2114         fi
2115
2116 # target to rebuild all man pages (both groff and html output)
2117 .PHONY: man
2118 man: $(man_MANS) $(manhtml)
2119
2120 # Target that builds all binaries (including those that are not
2121 # rebuilt except when running the tests)
2122 .PHONY: really-all
2123 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2124
2125 # we don't need the ancient implicit rules:
2126 %: %,v
2127 %: RCS/%,v
2128 %: RCS/%
2129 %: s.%
2130 %: SCCS/s.%
2131
2132 -include ./Makefile.local
2133
2134 # vim: set noet :